/* 
 * Leaflet Panel Layers v0.4.0 - 2016-09-28 
 * 
 * Copyright 2016 Stefano Cudini 
 * stefano.cudini@gmail.com 
 * http://labs.easyblog.it/ 
 * 
 * Licensed under the MIT license. 
 * 
 * Demos: 
 * http://labs.easyblog.it/maps/leaflet-panel-layers/ 
 * 
 * Source: 
 * git@github.com:stefanocudini/leaflet-panel-layers.git 
 * 
 */
(function(){L.Control.PanelLayers=L.Control.Layers.extend({options:{button:!1,collapsed:!1,autoZIndex:!0,position:"topright",collapsibleGroups:!1,buildItem:null},initialize:function(a,b,c){L.setOptions(this,c),this._layers={},this._groups={},this._items={},this._layersActives=[],this._lastZIndex=0,this._handlingClick=!1;var d,e,f;for(d in a)if(a[d].group&&a[d].layers){f=a[d].collapsed||!1;for(e in a[d].layers)this._addLayer(a[d].layers[e],!1,a[d].group,f)}else this._addLayer(a[d],!1);for(d in b)if(b[d].group&&b[d].layers){f=b[d].collapsed||!1;for(e in b[d].layers)this._addLayer(b[d].layers[e],!0,b[d].group,f)}else this._addLayer(b[d],!0)},onAdd:function(a){for(var b in this._layersActives)a.addLayer(this._layersActives[b]);return L.Control.Layers.prototype.onAdd.call(this,a),this._container},addBaseLayer:function(a,b,c){return a.name=b||a.name||"",this._addLayer(a,!1,c),this._update(),this},addOverlay:function(a,b,c){return a.name=b||a.name||"",this._addLayer(a,!0,c),this._update(),this},removeLayer:function(a){var b=a.hasOwnProperty("layer")?this._layerFromDef(a):a;return this._map.removeLayer(b),L.Control.Layers.prototype.removeLayer.call(this,b),this},clearLayers:function(){for(var a in this._layers)this.removeLayer(this._layers[a])},_layerFromDef:function(a){for(var b in this._layers)if(this._layers[b].name===a.name)return this._layers[b].layer},_update:function(){this._groups={},this._items={},L.Control.Layers.prototype._update.call(this)},_instantiateLayer:function(a){return a instanceof L.Class?a:a.type&&a.args?this._getPath(L,a.type).apply(L,a.args):void 0},_addLayer:function(a,b,c,d){var e=a.hasOwnProperty("layer")?this._instantiateLayer(a.layer):a,f=L.stamp(e);a.active&&this._layersActives.push(e),this._layers[f]=L.Util.extend(a,{overlay:b,group:c,layer:e,collapsed:d}),this.options.autoZIndex&&e.setZIndex&&(this._lastZIndex++,e.setZIndex(this._lastZIndex))},_createItem:function(a){var b,c,d,e="leaflet-panel-layers";if(b=L.DomUtil.create("label",e+"-item"),d=this._map.hasLayer(a.layer),a.overlay?(c=document.createElement("input"),c.type="checkbox",c.className="leaflet-control-layers-selector",c.defaultChecked=d):c=this._createRadioElement("leaflet-base-layers",d),c.value=L.stamp(a.layer),L.DomEvent.on(c,"click",this._onInputClick,this),b.appendChild(c),a.icon){var f=L.DomUtil.create("i",e+"-icon");f.innerHTML=a.icon||"",b.appendChild(f)}var g=document.createElement("span");if(this.options.buildItem){var h=this.options.buildItem.call(this,a);if("string"==typeof h){var i=L.DomUtil.create("div");i.innerHTML=h,g=i.firstChild}else g=h}else g.innerHTML=a.name||"";return b.appendChild(g),this._items[c.value]=b,b},_addItem:function(a){var b,c=this,d=a.overlay?this._overlaysList:this._baseLayersList;if(a.group){if(a.group.hasOwnProperty("name")||(a.group={name:a.group}),!this._groups[a.group.name]){var e=!1;a.collapsed===!0&&(e=!0),this._groups[a.group.name]=this._createGroup(a.group,e)}d.appendChild(this._groups[a.group.name]),d=this._groups[a.group.name]}return b=this._createItem(a),d.appendChild(b),a.group&&setTimeout(function(){c._container.style.width=c._container.clientWidth-5+"px"},100),b},_createGroup:function(a,b){var c,d,e="leaflet-panel-layers",f=L.DomUtil.create("div",e+"-group");return this.options.collapsibleGroups&&(L.DomUtil.addClass(f,"collapsible"),d=L.DomUtil.create("i",e+"-icon",f),b===!0?d.innerHTML=" + ":d.innerHTML=" - ",L.DomEvent.on(d,"click",function(){L.DomUtil.hasClass(f,"expanded")?(L.DomUtil.removeClass(f,"expanded"),d.innerHTML=" + "):(L.DomUtil.addClass(f,"expanded"),d.innerHTML=" - ")}),b===!1&&L.DomUtil.addClass(f,"expanded")),c=L.DomUtil.create("label",e+"-grouplabel",f),c.innerHTML="<span>"+a.name+"</span>",f},_onInputClick:function(){var a,b,c,d=this._form.getElementsByTagName("input"),e=d.length;for(this._handlingClick=!0,a=0;e>a;a++)b=d[a],c=this._layers[b.value],b.checked&&!this._map.hasLayer(c.layer)?this._map.addLayer(c.layer):!b.checked&&this._map.hasLayer(c.layer)&&this._map.removeLayer(c.layer);this._handlingClick=!1,this._refocusOnMap()},_initLayout:function(){var a="leaflet-panel-layers",b="leaflet-control-layers",c=this._container=L.DomUtil.create("div",a);c.setAttribute("aria-haspopup",!0),L.Browser.touch?L.DomEvent.on(c,"click",L.DomEvent.stopPropagation):L.DomEvent.disableClickPropagation(c).disableScrollPropagation(c);var d=this._form=L.DomUtil.create("form",a+"-list");if(this._map.on("resize",function(a){d.style.height=a.newSize.y+"px"}),d.style.height=this._map.getSize().y+"px",this.options.button&&(this.options.collapsed=!0,L.DomUtil.addClass(c,a+"-button-collapse")),this.options.collapsed){L.Browser.android||L.DomEvent.on(c,"mouseover",this._expand,this).on(c,"mouseout",this._collapse,this);var e=this._layersLink=L.DomUtil.create("a",b+"-toggle",c);e.href="#",e.title="Layers",L.Browser.touch?L.DomEvent.on(e,"click",L.DomEvent.stop).on(e,"click",this._expand,this):L.DomEvent.on(e,"focus",this._expand,this),this._map.on("click",this._collapse,this)}else this._expand();this._baseLayersList=L.DomUtil.create("div",a+"-base",d),this._separator=L.DomUtil.create("div",a+"-separator",d),this._overlaysList=L.DomUtil.create("div",a+"-overlays",d),L.DomUtil.create("div",a+"-margin",d),c.appendChild(d)},_expand:function(){L.DomUtil.addClass(this._container,"leaflet-panel-layers-expanded")},_collapse:function(){this._container.className=this._container.className.replace(" leaflet-panel-layers-expanded","")},_getPath:function(a,b){var c=b.split("."),d=c.pop(),e=c.length,f=c[0],g=1;if(e>0)for(;(a=a[f])&&e>g;)f=c[g++];return a?a[d]:void 0}}),L.control.panelLayers=function(a,b,c){return new L.Control.PanelLayers(a,b,c)}}).call(this);